#! /bin/sh
#
#   copy.sh -- 顼̵뤷ƥǡ򥳥ԡ
#
#	Ȥ: /bin/sh copy.sh ԡǥ ԡǥ
#		ǥ: ǥХեǻꡢƬΡ/dev/rפϾʤ
#		: /bin/sh copy.sh ad0 ad1
#
#	0.0: Aug.  5, 2006 by Dai ISHIJIMA (for wpout07)
#	0.1: Feb. 10, 2007 (Ͽ for wpout08)
#

srcdisk="${1:-ad0}"
dstdisk="${2:-ad1}"
dmesg="${DMESG:-/var/run/dmesg.boot}"
# ٤32MХȤ
blklen="${BLKLEN:-33554432}"
# ֥å512Х
cbs="${CBS:-512}"
ccnt=`expr $blklen / $cbs`

if [ ! -w /dev/r$dstdisk ]; then
	echo "$0: disk '$dstdisk' does not exist or is not writable"
	echo "Usage: $0 srcdisk dstdist"
	exit 1
fi

title="${TITLE:-ϡɥǥõġwipe-out}"

sname=`sed -n -E "/^${srcdisk}:.*<.*>/p" $dmesg | sed 's/.*\(<.*>\).*/\1/'`
sbytes=`diskinfo -B /dev/r$srcdisk`
dname=`sed -n -E "/^${dstdisk}:.*<.*>/p" $dmesg | sed 's/.*\(<.*>\).*/\1/'`
dbytes=`diskinfo -B /dev/r$dstdisk`

msg="ǥ ${srcdisk} ${sname} \n"
msg="${msg}ǡ ${sbytes}ХȤ\n"
msg="${msg}ǥ ${dstdisk} ${dname}\n"
msg="${msg}(${dbytes}Х) ˥ԡޤ"
msg="${msg}\n                      Ǥ?"

dialog --title "$title" --yesno "$msg" 9 64

case x"$?" in
	x1)
		dialog	--title "$title" \
			--infobox 'ǥΥԡ򥭥󥻥뤷ޤ' 3 64
		sleep 2
		exit 1
		;;
esac


msg="${srcdisk}Υǡ${dstdisk}˥ԡƤǤ?"

dialog	--title "$title" \
	--hline "$dname" \
	--yesno "$msg" \
	5 72

case x"$?" in
	x1)
		dialog	--title "$title" \
			--infobox 'ǥΥԡ򥭥󥻥뤷ޤ' 3 64
		sleep 2
		exit 1
		;;
esac

# ԡΥѥ᡼
bytes=`diskinfo -b /dev/r$srcdisk`
max=`expr '(' $bytes + $cbs - 1 ')' / $cbs`

startsec=`tinydate '+%s'`
rems=''

#
echo -n "copy started: $srcdisk ($sname) -> $dstdisk ($dname) " >> $LOGFIL
echo -n "$bytes bytes with $method on " >> $LOGFIL
date >> $LOGFIL

skip=0
while [ $skip -le $max ]; do
	# ׻
	cursec=`tinydate '+%s'`
	# С
	p=`expr 100 '*' $skip / $max`
	m=`expr 1000 '*' $skip / $max`
	q=`expr $p / 2`
	i=0
	bar=''
	while [ $i -lt $q ]; do
		bar="$bar"'#'
		i=`expr $i + 1`
	done
	while [ $i -lt 50 ]; do
		bar="$bar"'_'
		i=`expr $i + 1`
	done
	# Ĥ
	elapsed=`expr $cursec - $startsec`
	if [ $m -gt 0 ]; then
		remain=`expr '(' 1000 - $m ')' '*' $elapsed / $m + 1`
		if [ $remain -gt 120 ]; then
			rems=`expr '(' $remain + 59 ')' / 60`
			rems="Ĥ 褽${rems}ʬ"
		else
			rems="Ĥ 褽${remain}"
		fi
	fi
	if [ $elapsed -gt 120 ]; then
		elas=`expr '(' $elapsed + 30 ')' / 60`
		elas="${elas}ʬ"
	else
		elas="${elapsed}"
	fi
	#
	text="ǥ ${srcdisk} Υǡ ${dstdisk}˥ԡƤޤ"
	text="${text} ${p}% λ\n"
	text="${text}${elas} в  ${rems}  \n\n"
	text="${text}        0%|${bar}|100%"
	text="${text}\n${errormsg}"
	dialog --title "$title" --infobox "$text" 7 72
	echo -n "$status2"
	case x$DEBUG in
		x[Yy]*)
			status2='now in debug mode...'
			errormsg=''
			sleep 1
			;;
		*)
			status=`dd if=/dev/r$srcdisk ibs=$cbs skip=$skip conv=noerror,sync obs=$cbs seek=$skip count=$ccnt of=/dev/r$dstdisk 2>&1`
			status2=`echo "$status" | sed -n '/transfer/p'`
			errormsg=`echo "$status" | sed -n -E '/records (in|out)$/!p' | sed -n '/transferred in/!p'`
			;;
	esac
	# 롼
	skip=`expr $skip + $ccnt`
done

sleep 2

#
echo -n "copy finished: $srcdisk ($sname) -> $dstdisk ($dname) " >> $LOGFIL
echo -n "$bytes bytes with $method on " >> $LOGFIL
date >> $LOGFIL

cursec=`tinydate '+%s'`
elapsed=`expr $cursec - $startsec`
if [ $elapsed -gt 120 ]; then
	min=`expr $elapsed / 60`
	sec=`expr $elapsed - $min '*' 60`
	elas="${min}ʬ${sec}"
else
	elas="${elapsed}"
fi

dialog	--title "$title" \
	--msgbox "ǥΥԡλޤ (${elas})" 5 72

exit 0

# EOF
